Anniversary party--树形DP

Anniversary party

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 9692    Accepted Submission(s): 4153


Problem Description
There is going to be a party to celebrate the 80-th Anniversary of the Ural State University. The University has a hierarchical structure of employees. It means that the supervisor relation forms a tree rooted at the rector V. E. Tretyakov. In order to make the party funny for every one, the rector does not want both an employee and his or her immediate supervisor to be present. The personnel office has evaluated conviviality of each employee, so everyone has some number (rating) attached to him or her. Your task is to make a list of guests with the maximal possible sum of guests' conviviality ratings.
 

Input
Employees are numbered from 1 to N. A first line of input contains a number N. 1 <= N <= 6 000. Each of the subsequent N lines contains the conviviality rating of the corresponding employee. Conviviality rating is an integer number in a range from -128 to 127. After that go T lines that describe a supervisor relation tree. Each line of the tree specification has the form: 
L K 
It means that the K-th employee is an immediate supervisor of the L-th employee. Input is ended with the line 
0 0
 

Output
Output should contain the maximal sum of guests' ratings.
 

Sample Input
  
  
7 1 1 1 1 1 1 1 1 3 2 3 6 4 7 4 4 5 3 5 0 0
 

Sample Output
  
  
5

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1520


这是我接触树形DP的第一个题,和DP一样,自己想死活想不出来,我想到的只有暴力,但暴力绝对的超时,我就去看了题解,恩,看题解就懂了。。。。服气自己了,再加油吧,加油加油。


题意大概是说某公司要举办一次晚会,但是为了使得晚会的气氛更加活跃,每个参加晚会的人都不希望在晚会中见到他的直接上司(上司没有传递关系),现在已知每个人的活跃指数和上司关系(当然不可能存在环),求邀请哪些人(多少人)来能使得晚会的总活跃指数最大。


任何一个点的取舍可以看作一种决策,那么状态就是在某个点取的时候或者不取的时候,以他为根的子树能有的最大活跃总值。

分别可以用f[i,1]f[i,0]表示第i个人来和不来。


当i来的时候,dp[i][1] += dp[j][0];//j为i的下属

当i不来的时候,dp[i][0] +=max(dp[j][1],dp[j][0]);//j为i的下属


其实仔细想想也就是那么回事,这是个树形DP入门题,对于DP,我真的心好累。。。


这个题poj也有我从poj上面交的代码到hdu上交超时,杭电的数据是得有多硬。。。我就用链式前向星优化了一下,过了。。只

从hdu上跑了140ms多,差别好大啊,hdu的数据就是卡暴力的吧。


poj代码:

#include <cstdio>
#include <cstring>
#include <iostream>
using namespace std;
int vis[10000];
int dp[10000][2];
int father[10000];
int n;
void dfs(int x){
    vis[x]=1;
    for(int i=1;i<=n;i++){
        if(father[i]==x&&!vis[i]){//暴力查找父节点,应该就是卡这儿超时
            dfs(i);
            dp[x][1]+=dp[i][0];//状态转移方程
            dp[x][0]+=max(dp[i][0],dp[i][1]);
        }
    }
}
int main(){
    while(~scanf("%d",&n)){
        memset(dp,0,sizeof(dp));
        memset(father,0,sizeof(father));
        memset(vis,0,sizeof(vis));
        for(int i=1;i<=n;i++){
            scanf("%d",&dp[i][1]);
        }
        while(1){
            int x,y;
            scanf("%d%d",&x,&y);
            if(x+y==0){
                break;
            }
            father[x]=y;
        }
        int i;
        for(i=1;i<=n;i++){
            if(father[i]==0){
                break;
            }
        }
        dfs(i);
        printf("%d\n",max(dp[i][0],dp[i][1]));
    }
    return 0;
}

hdu代码:

#include <cstdio>
#include <cstring>
#include <iostream>
using namespace std;
int val[6600];
int in[6600];
struct node{
    int to;
    int next;
}edge[6600];
int pre[6600],cnt;
int dp[6600][2];
void init(){
    cnt=0;
    memset(pre,-1,sizeof(pre));
    memset(dp,0,sizeof(dp));
    memset(in,0,sizeof(in));
}
void add_edge(int u,int v){//气的我直接上前向星
    edge[cnt].to=v;
    edge[cnt].next=pre[u];
    pre[u]=cnt++;
}
int dfs(int u){
    dp[u][0]=0;
    dp[u][1]=val[u];
    for(int i=pre[u];i!=-1;i=edge[i].next){//这里不用查找父节点省了好多时间
        int v=edge[i].to;
        dfs(v);
        dp[u][0]+=max(dp[v][0],dp[v][1]);
        dp[u][1]+=dp[v][0];
    }
    return max(dp[u][0],dp[u][1]);
}
int main(){
    int n;
    while(~scanf("%d",&n)){
        init();
        for(int i=1;i<=n;i++){
            scanf("%d",&val[i]);
        }
        for(int i=0;;i++){
            int t1,t2;
            scanf("%d%d",&t1,&t2);
            if(t1==0&&t2==0)
                break;
            add_edge(t2,t1);
            in[t1]++;
        }
        int ans=0;
        for(int i=1;i<=n;i++){
            if(in[i]==0){
                ans+=dfs(i);
            }
        }
        printf("%d\n",ans);
    }
    return 0;
}


  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值